FullyQualifiedNameTriplet (Apache FOP 2.7 API)
Date: 2022-01-12

org.apache.fop.afp.modca.triplets

## Class FullyQualifiedNameTriplet

- java.lang.Object
- - org.apache.fop.afp.modca.AbstractAFPObject
  - - org.apache.fop.afp.modca.triplets.AbstractTriplet
    - - org.apache.fop.afp.modca.triplets.FullyQualifiedNameTriplet

- All Implemented Interfaces:
    Triplet, Streamable, StructuredData

      public class FullyQualifiedNameTriplet
      extends AbstractTriplet

  A Fully Qualified Name triplet enable the identification and referencing of objects using Gloabl Identifiers (GIDs).

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.fop.afp.modca.AbstractAFPObject

      `AbstractAFPObject.Category, AbstractAFPObject.Type`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static byte` | `FORMAT_CHARSTR` The GID is a character encoded name.
    `static byte` | `FORMAT_OID` the GID is a ASN.1 object identifier (OID).
    `static byte` | `FORMAT_URL` the GID is a uniform resource locator (URL).
    `static byte` | `TYPE_ATTRIBUTE_GID` The triplet contains a GID reference to a document attribute.
    `static byte` | `TYPE_BEGIN_DOCUMENT_INDEX_REF` The triplet contains a GID reference to a begin document index structured field.
    `static byte` | `TYPE_BEGIN_DOCUMENT_REF` The triplet contains a reference to a begin document structured field.
    `static byte` | `TYPE_BEGIN_MEDIUM_MAP_REF` The triplet contains a GID reference to a begin medium map structured field.
    `static byte` | `TYPE_BEGIN_OVERLAY_REF` The triplet contains a GID reference to a begin overlay structured field.
    `static byte` | `TYPE_BEGIN_PAGE_GROUP_REF` The triplet contains a reference to a begin page group structured field.
    `static byte` | `TYPE_BEGIN_PAGE_REF` The triplet contains a GID reference to a begin page structured field.
    `static byte` | `TYPE_BEGIN_RESOURCE_GROUP_REF` The triplet contains a GID reference to a begin resource group structured field.
    `static byte` | `TYPE_BEGIN_RESOURCE_OBJECT_REF` The triplet contains a reference to a begin structured field associated with a resource; or contains a GID reference to a coded font.
    `static byte` | `TYPE_CODE_PAGE_NAME_REF` The triplet contains a GID reference to a code page that specifies the code points and graphic character names for a coded font.
    `static byte` | `TYPE_CODED_FONT_NAME_REF` The triplet contains a GID reference to a coded font, which identifies a specific code page and a specific font character set.
    `static byte` | `TYPE_COLOR_MANAGEMENT_RESOURCE_REF` The triplet contains a reference to a color management resource.
    `static byte` | `TYPE_DATA_OBJECT_EXTERNAL_RESOURCE_REF` The triplet contains a reference to a resource used by a data object.
    `static byte` | `TYPE_DATA_OBJECT_FONT_BASE_FONT_ID` The triplet contains a reference to a data-object font file that defines a base font.
    `static byte` | `TYPE_DATA_OBJECT_FONT_LINKED_FONT_ID` The triplet contains a reference to a data-object font file that defines a linked font.
    `static byte` | `TYPE_DATA_OBJECT_INTERNAL_RESOURCE_REF` The triplet contains a GID reference to a resource used by a data object.
    `static byte` | `TYPE_FONT_CHARSET_NAME_REF` The triplet contains a GID name reference to a font character set that specifies a set of graphics characters.
    `static byte` | `TYPE_FONT_FAMILY_NAME` This triplet contains the name of a font family.
    `static byte` | `TYPE_FONT_TYPEFACE_NAME` This triplet contains the name of a font typeface.
    `static byte` | `TYPE_INDEX_ELEMENT_GID` The triplet contains a GID reference to an index element structured field.
    `static byte` | `TYPE_MEDIA_TYPE_REF` The triplet contains a reference to a media type.
    `static byte` | `TYPE_MODCA_RESOURCE_HIERARCHY_REF` This triplet specifies a reference to the MO:DCA resource hierarchy.
    `static byte` | `TYPE_OTHER_OBJECT_DATA_REF` The triplet contains a reference to other object data which may or may not be defined by an IBM presentation architecture.
    `static byte` | `TYPE_PROCESS_ELEMENT_GID` The triplet contains the GID of a process element.
    `static byte` | `TYPE_REPLACE_FIRST_GID_NAME` This GID replaces the first parameter in the structured field that contains a GID name.

    - ### Fields inherited from class org.apache.fop.afp.modca.triplets.AbstractTriplet

      `id`

    - ### Fields inherited from class org.apache.fop.afp.modca.AbstractAFPObject

      `LOG, SF_CLASS, SF_HEADER_LENGTH`

    - ### Fields inherited from interface org.apache.fop.afp.modca.triplets.Triplet

      `AREA_DEFINITION, ATTRIBUTE_QUALIFIER, ATTRIBUTE_VALUE, CHARACTER_ROTATION, CMR_TAG_FIDELITY, CODED_GRAPHIC_CHARACTER_SET_GLOBAL_IDENTIFIER, COLOR_FIDELITY, COLOR_MANAGEMENT_RESOURCE_DESCRIPTOR, COLOR_SPECIFICATION, COMMENT, DATA_OBJECT_FONT_DESCRIPTOR, DESCRIPTOR_POSITION, DEVICE_APPEARANCE, ENCODING_SCHEME_ID, EXTENDED_RESOURCE_LOCAL_IDENTIFIER, FINISHING_FIDELITY, FINISHING_OPERATION, FONT_DESCRIPTOR_SPECIFICATION, FONT_FIDELITY, FONT_HORIZONTAL_SCALE_FACTOR, FONT_RESOLUTION_AND_METRIC_TECHNOLOGY, FULLY_QUALIFIED_NAME, LOCALE_SELECTOR, MAPPING_OPTION, MAX_LENGTH, MEASUREMENT_UNITS, MEDIA_EJECT_CONTROL, MEDIA_FIDELITY, MEDIUM_MAP_PAGE_NUMBER, MEDIUM_ORIENTATION, MODCA_INTERCHANGE_SET, OBJECT_AREA_SIZE, OBJECT_BYTE_EXTENT, OBJECT_BYTE_OFFSET, OBJECT_CLASSIFICATION, OBJECT_COUNT, OBJECT_DATE_AND_TIMESTAMP, OBJECT_FUNCTION_SET_SPECIFICATION, OBJECT_OFFSET, OBJECT_STRUCTURED_FIELD_EXTENT, OBJECT_STRUCTURED_FIELD_OFFSET, PAGE_OVERLAY_CONDITIONAL_PROCESSING, PAGE_POSITION_INFORMATION, PARAMETER_VALUE, PRESENTATION_CONTROL, PRESENTATION_SPACE_MIXING_RULE, PRESENTATION_SPACE_RESET_MIXING, RENDERING_INTENT, RESOURCE_LOCAL_IDENTIFIER, RESOURCE_OBJECT_INCLUDE, RESOURCE_SECTION_NUMBER, RESOURCE_USAGE_ATTRIBUTE, TEXT_FIDELITY, TONER_SAVER, UNIVERSAL_DATE_AND_TIMESTAMP, UP3I_FINISHING_OPERATION`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FullyQualifiedNameTriplet(byte type, byte format, java.lang.String fqName, boolean utf16be)` Main constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getDataLength()` Returns the data length of this structured field
    `java.lang.String` | `getFullyQualifiedName()` Returns the actual fully qualified name
    `java.lang.String` | `toString()`
    `void` | `writeToStream(java.io.OutputStream os)` DataStream objects must implement the writeToStream() method to write its data to the given OutputStream

    - ### Methods inherited from class org.apache.fop.afp.modca.triplets.AbstractTriplet

      `getData, getId`

    - ### Methods inherited from class org.apache.fop.afp.modca.AbstractAFPObject

      `copySF, copySF, truncate, writeChunksToStream, writeObjects`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### TYPE_REPLACE_FIRST_GID_NAME

          public static final byte TYPE_REPLACE_FIRST_GID_NAME

      This GID replaces the first parameter in the structured field that contains a GID name.
      See Also:
        Constant Field Values

    - #### TYPE_FONT_FAMILY_NAME

          public static final byte TYPE_FONT_FAMILY_NAME

      This triplet contains the name of a font family.
      See Also:
        Constant Field Values

    - #### TYPE_FONT_TYPEFACE_NAME

          public static final byte TYPE_FONT_TYPEFACE_NAME

      This triplet contains the name of a font typeface.
      See Also:
        Constant Field Values

    - #### TYPE_MODCA_RESOURCE_HIERARCHY_REF

          public static final byte TYPE_MODCA_RESOURCE_HIERARCHY_REF

      This triplet specifies a reference to the MO:DCA resource hierarchy.
      See Also:
        Constant Field Values

    - #### TYPE_BEGIN_RESOURCE_GROUP_REF

          public static final byte TYPE_BEGIN_RESOURCE_GROUP_REF

      The triplet contains a GID reference to a begin resource group structured field.
      See Also:
        Constant Field Values

    - #### TYPE_ATTRIBUTE_GID

          public static final byte TYPE_ATTRIBUTE_GID

      The triplet contains a GID reference to a document attribute.
      See Also:
        Constant Field Values

    - #### TYPE_PROCESS_ELEMENT_GID

          public static final byte TYPE_PROCESS_ELEMENT_GID

      The triplet contains the GID of a process element.
      See Also:
        Constant Field Values

    - #### TYPE_BEGIN_PAGE_GROUP_REF

          public static final byte TYPE_BEGIN_PAGE_GROUP_REF

      The triplet contains a reference to a begin page group structured field.
      See Also:
        Constant Field Values

    - #### TYPE_MEDIA_TYPE_REF

          public static final byte TYPE_MEDIA_TYPE_REF

      The triplet contains a reference to a media type.
      See Also:
        Constant Field Values

    - #### TYPE_COLOR_MANAGEMENT_RESOURCE_REF

          public static final byte TYPE_COLOR_MANAGEMENT_RESOURCE_REF

      The triplet contains a reference to a color management resource.
      See Also:
        Constant Field Values

    - #### TYPE_DATA_OBJECT_FONT_BASE_FONT_ID

          public static final byte TYPE_DATA_OBJECT_FONT_BASE_FONT_ID

      The triplet contains a reference to a data-object font file that defines a base font.
      See Also:
        Constant Field Values

    - #### TYPE_DATA_OBJECT_FONT_LINKED_FONT_ID

          public static final byte TYPE_DATA_OBJECT_FONT_LINKED_FONT_ID

      The triplet contains a reference to a data-object font file that defines a linked font.
      See Also:
        Constant Field Values

    - #### TYPE_BEGIN_DOCUMENT_REF

          public static final byte TYPE_BEGIN_DOCUMENT_REF

      The triplet contains a reference to a begin document structured field.
      See Also:
        Constant Field Values

    - #### TYPE_BEGIN_RESOURCE_OBJECT_REF

          public static final byte TYPE_BEGIN_RESOURCE_OBJECT_REF

      The triplet contains a reference to a begin structured field associated with a resource; or contains a GID reference to a coded font.
      See Also:
        Constant Field Values

    - #### TYPE_CODE_PAGE_NAME_REF

          public static final byte TYPE_CODE_PAGE_NAME_REF

      The triplet contains a GID reference to a code page that specifies the code points and graphic character names for a coded font.
      See Also:
        Constant Field Values

    - #### TYPE_FONT_CHARSET_NAME_REF

          public static final byte TYPE_FONT_CHARSET_NAME_REF

      The triplet contains a GID name reference to a font character set that specifies a set of graphics characters.
      See Also:
        Constant Field Values

    - #### TYPE_BEGIN_PAGE_REF

          public static final byte TYPE_BEGIN_PAGE_REF

      The triplet contains a GID reference to a begin page structured field.
      See Also:
        Constant Field Values

    - #### TYPE_BEGIN_MEDIUM_MAP_REF

          public static final byte TYPE_BEGIN_MEDIUM_MAP_REF

      The triplet contains a GID reference to a begin medium map structured field.
      See Also:
        Constant Field Values

    - #### TYPE_CODED_FONT_NAME_REF

          public static final byte TYPE_CODED_FONT_NAME_REF

      The triplet contains a GID reference to a coded font, which identifies a specific code page and a specific font character set.
      See Also:
        Constant Field Values

    - #### TYPE_BEGIN_DOCUMENT_INDEX_REF

          public static final byte TYPE_BEGIN_DOCUMENT_INDEX_REF

      The triplet contains a GID reference to a begin document index structured field.
      See Also:
        Constant Field Values

    - #### TYPE_BEGIN_OVERLAY_REF

          public static final byte TYPE_BEGIN_OVERLAY_REF

      The triplet contains a GID reference to a begin overlay structured field.
      See Also:
        Constant Field Values

    - #### TYPE_DATA_OBJECT_INTERNAL_RESOURCE_REF

          public static final byte TYPE_DATA_OBJECT_INTERNAL_RESOURCE_REF

      The triplet contains a GID reference to a resource used by a data object.
      See Also:
        Constant Field Values

    - #### TYPE_INDEX_ELEMENT_GID

          public static final byte TYPE_INDEX_ELEMENT_GID

      The triplet contains a GID reference to an index element structured field.
      See Also:
        Constant Field Values

    - #### TYPE_OTHER_OBJECT_DATA_REF

          public static final byte TYPE_OTHER_OBJECT_DATA_REF

      The triplet contains a reference to other object data which may or may not be defined by an IBM presentation architecture.
      See Also:
        Constant Field Values

    - #### TYPE_DATA_OBJECT_EXTERNAL_RESOURCE_REF

          public static final byte TYPE_DATA_OBJECT_EXTERNAL_RESOURCE_REF

      The triplet contains a reference to a resource used by a data object. The GID may be a filename or any other identifier associated with the resource and is used to located the resource object in the resource hierarchy. The data object that uses the resource may or may not be defined by an IBM presentation architecture.
      See Also:
        Constant Field Values

    - #### FORMAT_CHARSTR

          public static final byte FORMAT_CHARSTR

      The GID is a character encoded name.
      See Also:
        Constant Field Values

    - #### FORMAT_OID

          public static final byte FORMAT_OID

      the GID is a ASN.1 object identifier (OID).
      See Also:
        Constant Field Values

    - #### FORMAT_URL

          public static final byte FORMAT_URL

      the GID is a uniform resource locator (URL).
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### FullyQualifiedNameTriplet

          public FullyQualifiedNameTriplet(byte type,
                                           byte format,
                                           java.lang.String fqName,
                                           boolean utf16be)

      Main constructor
      Parameters:
        `type` - the fully qualified name type
        `format` - the fully qualified name format
        `fqName` - the fully qualified name

  - ### Method Detail

    - #### getFullyQualifiedName

          public java.lang.String getFullyQualifiedName()

      Returns the actual fully qualified name
      Returns:
        the actual fully qualified name

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getDataLength

          public int getDataLength()

      Returns the data length of this structured field
      Returns:
        the data length of this structured field

    - #### writeToStream

          public void writeToStream(java.io.OutputStream os)
                             throws java.io.IOException

      DataStream objects must implement the writeToStream() method to write its data to the given OutputStream
      Parameters:
        `os` - the outputsteam stream
      Throws:
        `java.io.IOException` - an I/O exception of some sort has occurred.

Copyright 1999-2022 The Apache Software Foundation. All Rights Reserved.